checkRequire("Lua_BeastSoulPropPanel");
Lua_BeastSoulPanel = class("Lua_BeastSoulPanel", Lua_DisplayObject);
function Lua_BeastSoulPanel:ctor(p)	
	self:superCall("ctor", p, "BeastSoulPanel_skin");
end

function Lua_BeastSoulPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.starArr = Array();
	self.selectIndex = 1;

	self.propPanel = Lua_BeastSoulPropPanel.new(self.content);
	self.propPanel:setLocation(368, 90, 0);

	self.beastSoulImg = UICreate.createImage(self.content, "", -6, -1, 0, 0);
	self.beastSoulImg:setDepth(10);

	self.btnList = Lua_DragCustomBtnList.new(self.content, 1, Vector4(0, -260, 370, 522));
	self.btnList:setLocation(-434, 260, 0);
	self.btnList:setMainBtnCell(Lua_BeastSoulBtnMainCell, 360, 65, 0, 0);
	self.btnList:setSubBtnCell(Lua_BeastSoulBtnSubCell, 354, 115, 0, 0);
	-- self.btnList.clickDrawBack = true;
	self.btnList:setDepth(5);

	self.btnNames = Array();
    self.btnNames:add({ name = LanUtil.getValue(143471) });
    self.btnNames:add({ name = LanUtil.getValue(143472) });
    self.propBtnList = Lua_ButtonList.new(self.content, self.btnNames, 130, self, self.onPropBtnClick,
    	"tab1_souchong_normal", "tab1_souchong_select", Vector4(0, 0, 115, 45), Vector4(0, 0, 120, 50),
    	Lua_ColorDefine.transColor("394463"), Lua_ColorDefine.BROWN, Vector4(22, 22, 100, 24), 2);
    self.propBtnList:setLocation(305, 235, 0);
    self.propBtnList:setDepth(5);

	self.upStartDot = UICreate.createUIAtlasImage(self.content, "iconantlas4", "redDot", 355, 250, 0, 0);
	self.upStartDot:setDepth(10);
	self.upStartDot:setEnable(false);

	self.intensifyDot = UICreate.createUIAtlasImage(self.content, "iconantlas4", "redDot", 485, 250, 0, 0);
	self.intensifyDot:setDepth(10);
	self.intensifyDot:setEnable(false);

    self.cost_217040002.clickScale = false;
    self.cost_217040002:addClickFuntion(self, self.onCostItemClick);
    self.cost_217040003.clickScale = false;
    self.cost_217040003:addClickFuntion(self, self.onCostItemClick);
    self.cost_217040004.clickScale = false;
    self.cost_217040004:addClickFuntion(self, self.onCostItemClick);

    self.helpBtn:addClickFuntion(self, self.onHelpBtnClick);
	self.resolveBtn:addClickFuntion(self, self.onResolveBtnClick);

	Lua_ProxyManager.getProxy("Lua_BeastSoulProxy"):sBeastSoulInfo();
	self:addLuaEvent("UPDATE_BEASTSOUL", self, self.updatePanelInfo);
	self:updatePanelInfo();
end

function Lua_BeastSoulPanel:dispose()
	for i = 1, self.starArr:getSize() do
		self.starArr[i]:dispose();
	end
	self.starArr:clear();

	if self.btnList == nil then
		self.btnList:dispose();
		self.btnList = nil;
	end

	if self.propBtnList ~= nil then
        self.propBtnList:dispose();
        self.propBtnList = nil;
    end

    if self.propPanel ~= nil then
		self.propPanel:dispose();
	end

	DataCenter.beastSoulData.selectMainIndex = 1;
	DataCenter.beastSoulData.selectZodiacId = 217020001;
	DataCenter.beastSoulData.selectIndex = 1;

	self:superCall("dispose");
end

function Lua_BeastSoulPanel:updatePanelInfo()
	local selectMainIndex = DataCenter.beastSoulData.selectMainIndex;
	local selectSubIndex = DataCenter.beastSoulData.selectSubIndex;

	self.btnList:setData(DataCenter.beastSoulUtil.beastSoulInfoArr, self, self.onBtnClick);
	self.btnList:setMainSlected(selectMainIndex, selectSubIndex);
end

function Lua_BeastSoulPanel:onBtnClick(data)
	self.data = data;

	if DataCenter.beastSoulData.selectZodiacId ~= data.id then
		DataCenter.beastSoulData.selectMainIndex = data.mainType;
		DataCenter.beastSoulData.selectZodiacId = data.id;
		DataCenter.beastSoulData.selectIndex = 1;
	end

	local len = data.star_lvl_limit;
	if self.starArr:getSize() ~= len then
		for i = 1, self.starArr:getSize() do
			self.starArr[i]:dispose();
		end
		self.starArr:clear();

		for i = 1, len do
			local star = UICreate.createUIAtlasImage(self.content, "iconantlas1", "star_0", 0, 0, 0, 0);
			star:setScale(0.85, 0.85, 0.85);
			star:setDepth(10);
			star:setLocation(-225 + i * 40, -198, 0);
			if i > 10 then
				star:setLocation(-225 + (i-10) * 40, -240, 0);
			end
			self.starArr:add(star);
		end
	end

	self.name.text = "Lv."..data.beastSoulLvl.."  "..data.name;
	if data.isActivate == 0 then
		self.stateLabel:setEnable(true);
		self.stateLabel.text = LanUtil.getValue(143405);
		self.beastSoulImg:setUrl(data.unImageStr);
		
		for i = 1, self.starArr:getSize() do
			self.starArr[i]:setEnable(false);
		end
	else
		self.stateLabel:setEnable(false);
		self.beastSoulImg:setUrl(data.imageStr);
		
		local _len = self.starArr:getSize();
		for i = 1, _len do
			self.starArr[i]:setEnable(true);
			if i > data.starLvl then
				self.starArr[i]:setGray(true);
			else
				self.starArr[i]:setGray(false);
			end
		end
	end

	self.costNum_1.text = DataCenter.beastSoulData.iCostCount_1;
    self.costNum_2.text = DataCenter.beastSoulData.iCostCount_2;
    self.costNum_3.text = DataCenter.beastSoulData.iCostCount_3;
    self.upStartDot:setEnable(data.isShowUpStarRed);
	self.intensifyDot:setEnable(data.isShowIntensifyRed);

	local selectIndex = DataCenter.beastSoulData.selectIndex;
    self.propBtnList:setSelected(selectIndex, false);
    self:onPropBtnClick(selectIndex);
end

function Lua_BeastSoulPanel:onPropBtnClick(val)
	-- 1:升星 2:强化 
	DataCenter.beastSoulData.selectIndex = val;
	if self.propPanel ~= nil then
		self.propPanel:setData(self.data, val);
	end
end

function Lua_BeastSoulPanel:onCostItemClick(go)
	local str = string.split(tostring(go.gameObject.name), "_");
	local vo = DataCenter.beastSoulUtil:getCostVoById(tonumber(str[2]));
	if vo ~= nil then
		Lua_PackUtil.showItemInfo(vo);
	end
end

function Lua_BeastSoulPanel:onHelpBtnClick(go)
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_OPEN, LanUtil.getValue(143448));
end

function Lua_BeastSoulPanel:onResolveBtnClick(go)
	Lua_WindowUtil.openWin("Lua_BeastSoulResolveWindow", WinParam.ACTION_OPEN);
end




















Lua_BeastSoulBtnMainCell = class("Lua_BeastSoulBtnMainCell", Lua_DragCustomBtnListCell);
function Lua_BeastSoulBtnMainCell:ctor(p, btnType, cellWidth, cellHeight, offsetX, offsetY, skin)
    self:superCall("ctor", p, btnType, cellWidth, cellHeight, offsetX, offsetY, "BeastSoulBtnMain_skin");
end

function Lua_BeastSoulBtnMainCell:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_BeastSoulBtnMainCell:updateData()
    self.btnLabel.text = "[192E41]" .. self._data.name .. "[-]";

    local bShow = false
    local arr = self._data.sub;
    local len = arr:getSize();
    if arr ~= nil and len > 0 then
    	for i = 1, len do
    		local vo = arr[i];
    		if vo ~= nil and (vo.isShowUpStarRed or vo.isShowIntensifyRed) then
    			bShow = true;
    			break;
    		end
    	end
    end
    self.redDot:setEnable(bShow);
end

function Lua_BeastSoulBtnMainCell:setSelected(val)
	self:superCall("setSelected", val);
    if val == true then
    	self.btnBg:setAltas("iconantlas1", "tab4_souchong_select");
    	self.arrow:setRot(0, 0, 0);
    else
    	self.btnBg:setAltas("iconantlas1", "tab4_souchong_normal");
    	self.arrow:setRot(0, 0, 90);
    end
end

function Lua_BeastSoulBtnMainCell:dispose()
    self:superCall("dispose");
end










Lua_BeastSoulBtnSubCell = class("Lua_BeastSoulBtnSubCell", Lua_DragCustomBtnListCell);
function Lua_BeastSoulBtnSubCell:ctor(p, btnType, cellWidth, cellHeight, offsetX, offsetY, skin)
    self:superCall("ctor", p, btnType, cellWidth, cellHeight, offsetX, offsetY, "BeastSoulBtnSub_skin");
end

function Lua_BeastSoulBtnSubCell:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_BeastSoulBtnSubCell:dispose()
    self:superCall("dispose");
end

function Lua_BeastSoulBtnSubCell:updateData()
	self.headImg:setAltas("item17", tostring(self._data.headId));
	self.name.text = "[192E41]" .. self._data.name .. "[-]";
	if self._data.isActivate == 0 then
		self.state.text = LanUtil.formateStr(LanUtil.getValue(143446), tostring(self._data.beastSoulLvl));
	else
		self.state.text = LanUtil.formateStr(LanUtil.getValue(143447), tostring(self._data.beastSoulLvl));
	end

	if self._data.isShowUpStarRed or self._data.isShowIntensifyRed then
		self.redDot:setEnable(true);
	else
		self.redDot:setEnable(false);
	end
end

function Lua_BeastSoulBtnSubCell:setSelected(val)
	self:superCall("setSelected", val);
    if val == true then
    	self.btnBg:setAltas("iconantlas1", "tab3_souchong_select");
    else
    	self.btnBg:setAltas("iconantlas1", "tab3_souchong_normal");
    end
end