Lua_SecretItem = class("Lua_SecretItem", Lua_DisplayObject);
function Lua_SecretItem:ctor(p)	
	self:superCall("ctor", p, "SecretItem_skin");
end

function Lua_SecretItem:buildShowItem()
	self:superCall("buildShowItem");

	self.headImg = UICreate.createImage(self.content, "", 1, -2, 0, 0);
	self.headImg:setDepth(4);

	self.redDot:setEnable(false);
end

function Lua_SecretItem:dispose()
	self:superCall("dispose");
end

function Lua_SecretItem:setData(data)
	self.data = data;
	self.headImg:setUrl(data.headStr);

	if data.id == 4 then
		self.arrow:setEnable(false);
	end

	if data.isActivate == 1 then
		self.bg:setGray(false);
		self.headImg:setGray(false);
		self.headImg.mouseEnable = true;
		self.headImg:addClickFuntion(self, self.onHeadImgClick);

		self.callObj:SetActive(true);
		if data.isFreeDraw == 1 then
			self.redDot:setEnable(true);
			self.money:setEnable(false);
			self.callTxt:setLocation(3, -62, 0);
			self.callTxt.text = LanUtil.getValue(143439);
		else
			self.redDot:setEnable(false);
			self.money:setEnable(true);
			self.callTxt:setLocation(-8, -62, 0);
			self.callTxt.text = data.copperDrawCost;
		end

		if data.copperDiscount == 0 then
			self.discountObj:SetActive(false);
		else
			self.discountObj:SetActive(true);
			self.discount.text = LanUtil.formateStr(LanUtil.getValue(143440), tostring(data.copperDiscount));
		end
	else
		self.bg:setGray(true);
		self.headImg:setGray(true);
		self.headImg.mouseEnable = false;
		self.headImg:setScale(1, 1, 1);
		self.headImg:removeClickFuntion(self, self.onHeadImgClick);
		self.callObj:SetActive(false);
		self.discountObj:SetActive(false);
	end
end

function Lua_SecretItem:onHeadImgClick(go)
	if self.data.isFreeDraw == 0 and DataCenter.moneyData:getMoney(Lua_MoneyData.COPPER) < self.data.copperDrawCost then
		local arr = Array();
        arr:add(Lua_ToolVo.new(Lua_MoneyData.COPPER, 1, 1));
        Lua_WindowUtil.openWin("Lua_ItemOutputWindow", nil, arr);
        OperateAlert.show(LanUtil.getValue(110816));
        return;
    end

    DataCenter.secretData.drawType = 0;
	Lua_ProxyManager.getProxy("Lua_SecretProxy"):sSecretDraw(self.data.id, 0, 0);
end