Lua_SecretPackWindow = class("Lua_SecretPackWindow", Lua_ThirdSizeWindow);
function Lua_SecretPackWindow:ctor()
	self:superCall("ctor", true, 3500, true,LanUtil.getValue(121416));
	self.w = 840;
	self.h = 570;
	self.windowName = "Lua_SecretPackWindow";
	self.skinName = "SecretPackWindow_skin";
	self.isClickClose = false;
end

function Lua_SecretPackWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.pagePosx = 0;
	self.pagePosy = -144;
	self.horizontal = 7;
	self.vertical = 4;
	self.pageSize = DataCenter.secretUtil.packSize;
	self.pageLen = math.ceil(self.pageSize / (self.horizontal * self.vertical));

	self.packList = Lua_DragList.new(self.content, 2, Vector4(0, 0, 690, 360));
	self.packList:setListCell(Lua_SecretPackItem, 360, 690, 1000);
	self.packList:setCellScaleChange(true, 1, 1, 690, self, self.onPageCallBack);
    self.packList:setLocation(0, 55, 0);

	self.pageTipList = Array();
    local perWidth = 40;
    for i = 1, self.pageLen do
        local pageSp = UICreate.createUIAtlasImage(self.content, "packWindow", "page_not", 0, 0, 26, 26);
        pageSp:setLocation(-1 * perWidth * self.pageLen / 2 + perWidth * (i-1) + perWidth / 2 + self.pagePosx, -144, 0);
        pageSp:setDepth(5);
        pageSp.name = tostring(i);
        pageSp:addClickFuntion(self, self.onPageClick);
        self.pageTipList:add(pageSp);
    end

	self.des.text = LanUtil.getValue(121414);
	self.pickUpBtn:addClickFuntion(self, self.onPickUpBtnClick);

	self.packList:moveToIndex(1, true);
    self:addLuaEvent("PACK_UPDATE", self, self.onPackDataUpdate);
    self:updatePackData();
end

function Lua_SecretPackWindow:dispose()
	if self.packList ~= nil then
    	self.packList:dispose()
    	self.packList = nil;
    end

    if self.pageTipList ~= nil then
	    local len = self.pageTipList:getSize();
	    for i = 1, len do
	        self.pageTipList[i]:dispose();
	    end
	    self.pageTipList:clear();
	    self.pageTipList = nil;
	end

	self:superCall("dispose");
end

function Lua_SecretPackWindow:onPackDataUpdate(packType)
    if packType == Lua_PackData.SECRET_PACK then -- 临时仓库更新
        self:updatePackData();
    end
end

function Lua_SecretPackWindow:onPickUpBtnClick(go)
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
        OperateAlert.show(LanUtil.getValue(121419));
        return;
    end
    self.clickTime = getTime();

    local bagData = DataCenter.packData:getBagType(Lua_PackData.SECRET_PACK);
    local arr = bagData:getBagAllData();
    if arr:getSize() <= 0 then
    	OperateAlert.show(LanUtil.getValue(121428));
    	return;
    end

    -- 一键取出
	Lua_ProxyManager.getProxy("Lua_SecretProxy"):sSecretPickUp(1, 0);
end

function Lua_SecretPackWindow:onPageClick(go)
    local num = tonumber(go.name);
    self.packList:moveToIndex(num);
end

function Lua_SecretPackWindow:onPageCallBack(val)
    local len = self.pageTipList:getSize();
    for i = 1, len do
        if i == val then
            self.pageTipList[i]:setAltas("packWindow", "page_show");
        else
            self.pageTipList[i]:setAltas("packWindow", "page_not");
        end
    end
end

function Lua_SecretPackWindow:updatePackData()
    local arr = Array();
    for i = 1, self.pageLen do
        local tb = {};
        tb.page = i;
        tb.startIndex = (i - 1) * 28;
        arr:add(tb);
    end
    self.packList:setLuaArrayData(arr);	
end




















Lua_SecretPackItem = class("Lua_SecretPackItem", Lua_ListCell);
function Lua_SecretPackItem:buildShowItem()
	self:superCall("buildShowItem");
	self.lastClickIndex = -1;
	self.lastClickTime = 0;
	self.cellPosX = {{-340, -260}, {-240, -160}, {-140, -60}, {-40, 40}, {60, 140}, {160, 240}, {260, 340}};
	self.cellPosY = {{175, 95}, {85, 5}, {-5, -85}, {-95, -175}};
	
	self.cells = Array();
	local perWidth = 100;
	local perHeight = 90;
	local startX = -perWidth * (7 - 1) / 2;
	local startY = perHeight * (4 - 1) / 2;
	for j = 1, 4 do
		for i = 1, 7 do
			local cell = Lua_ToolImage.new(self.content);
			cell.defaultRoundEffect = true;
			cell:setLocation(startX + (i - 1) * perWidth, startY - (j - 1) * perHeight, 0);
			cell:setDepth(4);
			cell:setCanClick(false);
			cell.content.name = "cell"..(i + (j - 1) * 7);
			self.cells:add(cell);
		end
	end
end
function Lua_SecretPackItem:checkOutBound(showRect)
	local len = self.cells:getSize();
	for i=1,len do
		if self.cells[i].data ~= nil then
			local rect = Lua_Rectangle.new(self.itemX + self.cells[i].x - 40, self.itemY + self.cells[i].y - 40, 80,80);
			if showRect:containeRect(rect) == true then
				self.cells[i]:showRoundEffectView(true);
			else
				self.cells[i]:showRoundEffectView(false);
			end
		end
	end
end
function Lua_SecretPackItem:dispose()
	Lua_CommonUtil.removeTimer(self, self.onSingleClick);

	self:superCall("dispose");
end

function Lua_SecretPackItem:setData(data)
	local st = data.startIndex;
	self.startIndex = st;
	local len = self.cells:getSize();
	local bagData = DataCenter.packData:getBagType(Lua_PackData.SECRET_PACK);
	local arr = bagData:getBagAllData()
	local packSize = bagData.packSize == nil and DataCenter.treasureUtil:getStoreSize() or bagData.packSize;
	for i = 1, len do
		local curIndex = st + i;
		self.cells[i].curIndex = self.cells[i];
		if curIndex - 1 >= packSize then
			self.cells[i].data = nil;
			self.cells[i]:setEnable(false);
		else
			local td = arr[curIndex];
			self.cells[i].data = td;
			self.cells[i]:setEnable(true);
		end
	end
end

function Lua_SecretPackItem:onPlayerSoundClick()
	local v = Vector3(UnityEngine.Input.mousePosition.x, UnityEngine.Input.mousePosition.y, 0);
	local screenpos = UICamera.mainCamera:ScreenToWorldPoint(v);
	local mousePosition = self.content.transform:InverseTransformPoint(screenpos);

	local cx = 0;
	for i, v in ipairs(self.cellPosX) do
		if v[1] <= mousePosition.x and v[2] > mousePosition.x then
			cx = i;
			break;
		end
	end
	if cx == 0 then
		return;
	end

	local cy = 0;
	for i, v in ipairs(self.cellPosY) do
		if v[1] > mousePosition.y and v[2] <= mousePosition.y then
			cy = i;
			break;
		end
	end
	if cy == 0 then
		return;
	end

	self.clickIndex = cx + (cy - 1) * 7;
	if self.lastClickIndex ~= self.clickIndex or getTime() - self.lastClickTime > 0.3 then
		self.lastClickTime = getTime();
		self.lastClickIndex = self.clickIndex;
		Lua_CommonUtil.delayCall(0.3, self, self.onSingleClick);
	else
		Lua_CommonUtil.removeTimer(self, self.onSingleClick);
		self:onDoubleClick();
		self.lastClickTime = -1;
	end
end

function Lua_SecretPackItem:onDoubleClick()
	local tvo = self.cells[self.clickIndex].data;
	if tvo == nil then
		return;
	end

	-- 取出
	Lua_ProxyManager.getProxy("Lua_SecretProxy"):sSecretPickUp(0, tvo.index);
end

function Lua_SecretPackItem:onSingleClick()
	local tvo = self.cells[self.clickIndex].data;
	if tvo == nil then
		return;
	end

	-- 展示tips
	Lua_PackUtil.showItemInfo(tvo);
end