-- 生肖装备强化
checkRequire("Lua_ZodiacIntensifyItem");
Lua_ZodiacIntensifyWindow = class("Lua_ZodiacIntensifyWindow", Lua_SecondSizeWindow);
function Lua_ZodiacIntensifyWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_ZodiacIntensifyWindow";
	self.skinName = "ZodiacIntensifyWindow_skin";
	self.titleText = LanUtil.getValue(143409);
end

function Lua_ZodiacIntensifyWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.isUping = false;
	self.selectZodiacId = DataCenter.zodiacData.selectZodiacId;

	self.btnList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 294, 532));
    self.btnList:setLocation(-334, -25, 0);
    self.btnList:setListCell(Lua_ZodiacIntensifyBtnItem, 115, 295, 1);

    self.itemList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 518, 136));
    self.itemList:setLocation(167, 117, 0);
    self.itemList:setListCell(Lua_ZodiacIntensifyHoleItem, 115, 130, 4);
    self.itemList.canDrag = false;

    self.dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(145, -55, 300, 150));
    self.dragContainer:setLocation(40, 10, 0);
    self.dragContainer.canDrag = false;

    self:setBarDefault();
    self.tipsLabel.text = LanUtil.getValue(143426);

    self.upJieObj:SetActive(false);
	self.upJieBtn:addClickFuntion(self, self.onUpJieBtnClick); -- 升阶

	self.upRedDot:setEnable(false);
    self.upBtn:addClickFuntion(self, self.onUpBtnClick); -- 提升

    self.autoUpRedDot:setEnable(false);
	self.autoUpBtn:addClickFuntion(self, self.onAutoUpBtnClick); -- 一键提升

	self:addLuaEvent("ZodiacIntensifyBtnSelected", self, self.onBtnSelected);
	self:addLuaEvent("ZodiacIntensifyItemSelected", self, self.onItemSelected);
	self:addLuaEvent("UPDATE_ALL_ZODIAC", self, self.updatePanelInfo);
    self:updatePanelInfo();
end

function Lua_ZodiacIntensifyWindow:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end

	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end

	if self.dragContainer ~= nil then
		self.dragContainer:removeAllChildren();
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end

	DataCenter.zodiacData.selectHolePart = 1;
	Lua_CommonUtil.removeTimer(self, self.onIntensifyAutoUp);

	self:superCall("dispose");
end

function Lua_ZodiacIntensifyWindow:updatePanelInfo()
	local arr = DataCenter.zodiacUtil.zodiacInfoArr;
	self.btnList:setLuaArrayData(arr, false);

	if arr:getSize() > 0 then
		local selectId = self.selectZodiacId;
		if selectId == nil then
			self.btnList:setSelected(1);
		else
			local len = arr:getSize();
			for i = 1, len do
				if arr[i].id == selectId then
					self.btnList:moveToIndex(i, true);
					self.btnList:setSelected(i);
				end
			end
		end
	end
end

function Lua_ZodiacIntensifyWindow:onBtnSelected(data)
	self.upRedDot:setEnable(false);
	self.autoUpRedDot:setEnable(false);
	if self.selectZodiacId ~= data.id then
		self.selectZodiacId = data.id;
		self.selectHolePart = 1;
	else
		self.selectHolePart = DataCenter.zodiacData.selectHolePart;
	end

	self.itemList:setLuaArrayData(data.holeVoArr, false);
	self.itemList:setSelected(self.selectHolePart);
end

function Lua_ZodiacIntensifyWindow:onItemSelected(data)
	if DataCenter.zodiacData.selectHolePart ~= data.holePart then
		DataCenter.zodiacData.selectHolePart = data.holePart;
	end

	if data.equipVo == nil then
		self:setBarDefault();
		self.upJieObj:SetActive(false);
		self.intensifyObj:SetActive(true);
		self.upBtn:setBtnEnable(false);
		self.autoUpBtn:setBtnEnable(false);
		self.dragContainer:removeAllChildren()
	    return;
	end

	self.holeVo = data;
	local arr = data.intensifyInfoArr;
	self.dragContainer:removeAllChildren();
	local len = arr:getSize();
	for i = 1, len do
		local item = Lua_ZodiacIntensifyItem.new(self.dragContainer.content);
		item:setData(arr[i]);
		-- self.itemArr:add(item);
		self.dragContainer:addSubContainer(item, false);
	end
	self.dragContainer:updateChildPos();

	if data.isMaxIntensify then
		if data.equipVo.color >= 5 and data.isMaxUpgrade == false then -- 红色品质且未达到最高阶
			self.intensifyObj:SetActive(false);
			self.upJieObj:SetActive(true);
			self.upJieRedDot:setEnable(data.isEquipCanUpgrade);
		else
			self.upJieObj:SetActive(false);
			self.intensifyObj:SetActive(true);
			self.upBtn:setBtnEnable(false);
			self.autoUpBtn:setBtnEnable(false);
		end
		self.upRedDot:setEnable(false);
		self.autoUpRedDot:setEnable(false);

		local propStr = LanUtil.formateStr(LanUtil.getValue(143458), tostring(data.intensifyProgress));
		self.proBar:setText(propStr);
		self.proBar:setMaxValue(data.intensifyVo.progress);
		self.proBar:setValue(data.intensifyProgress);  
	else
		self.upJieObj:SetActive(false);
		self.intensifyObj:SetActive(true);
		self.upBtn:setBtnEnable(true);
		self.autoUpBtn:setBtnEnable(true);
		
		self.upRedDot:setEnable(data.isEquipCanIntensify);
		self.autoUpRedDot:setEnable(data.isEquipCanIntensify);

		self.proBar:setText(tostring(data.intensifyProgress) .. "/" .. tostring(data.intensifyVo.progress));
		self.proBar:setMaxValue(data.intensifyVo.progress);
		self.proBar:setValue(data.intensifyProgress);
	end
end

function Lua_ZodiacIntensifyWindow:onUpBtnClick(go)
	if self.holeVo == nil then
		return;
	end

	if self.holeVo.isEquipCanIntensify == false then -- 材料不足
		OperateAlert.show(LanUtil.getValue(143467));
	else
		Lua_ProxyManager.getProxy("Lua_ZodiacProxy"):sIntensifyEquip(self.selectZodiacId, self.holeVo.equipVo.part);
	end
end

function Lua_ZodiacIntensifyWindow:onAutoUpBtnClick(go)
	if self.holeVo == nil then
		return;
	end

	if self.isUping == false then
		self.isUping = true;
		self.autoUpBtn.label = LanUtil.getValue(143427);
		self.upBtn:removeClickFuntion(self, self.onUpBtnClick);
        
        Lua_CommonUtil.addTimer("ZODIAC_INTENSIFY", 0.3, self, self.onIntensifyAutoUp, nil, -1);
	else
		self.isUping = false;
		self.autoUpBtn.label = LanUtil.getValue(143428);
		self.upBtn:addClickFuntion(self, self.onUpBtnClick);

        Lua_CommonUtil.removeTimer(self, self.onIntensifyAutoUp);
	end
end

function Lua_ZodiacIntensifyWindow:onIntensifyAutoUp()
	if self.lastTime == nil then
        self.lastTime = 0;
    end
    if (getTime() - self.lastTime > 0.05) then

        if self.holeVo.isMaxIntensify then -- 最高等级
			self:onAutoUpBtnClick();
		elseif self.holeVo.isEquipCanIntensify == false then -- 材料不足
			OperateAlert.show(LanUtil.getValue(143467));
			self:onAutoUpBtnClick();
		else
			Lua_ProxyManager.getProxy("Lua_ZodiacProxy"):sIntensifyEquip(self.selectZodiacId, self.holeVo.equipVo.part);
		end
		
        self.lastTime = getTime();
    end
end

function Lua_ZodiacIntensifyWindow:onUpJieBtnClick(go)
	local list = {};
	list.zodiacIndex = self.selectZodiacId;
	list.itemPart = self.holeVo.equipVo.part;
	list.intensifyLevel = self.holeVo.equipVo.intensifyLevel;
	Lua_WindowUtil.openWin("Lua_ZodiacEquipUpWindow", WinParam.ACTION_OPEN, list);
end

function Lua_ZodiacIntensifyWindow:setBarDefault()
	self.proBar:setText(tostring(0) .. "/" .. tostring(0));
    self.proBar:setMaxValue(0);
    self.proBar:setValue(0);
end



















Lua_ZodiacIntensifyBtnItem = class("Lua_ZodiacIntensifyBtnItem", Lua_ListCell);
function Lua_ZodiacIntensifyBtnItem:ctor(p)
    self:superCall("ctor", p, "ZodiacIntensifyBtn_skin");
end

function Lua_ZodiacIntensifyBtnItem:buildShowItem()
	self:superCall("buildShowItem");
	self.redDot:setEnable(false);
end

function Lua_ZodiacIntensifyBtnItem:dispose()
	self:superCall("dispose");
end

function Lua_ZodiacIntensifyBtnItem:setData(data)
	self.data = data;
	self.name.text = data.name;
	self.fraction.text = LanUtil.formateStr(LanUtil.getValue(143424), tostring(data.totalForce));

	if data.isEquipCanIntensify or data.isEquipCanUpgrade then
		self.redDot:setEnable(true);
	else
		self.redDot:setEnable(false);
	end
end

function Lua_ZodiacIntensifyBtnItem:onSelectionChange(val)
	self:superCall("onSelectionChange");
    if val == true and self.btnBg ~= nil then
		Lua_MsgUtil.callFunc("ZodiacIntensifyBtnSelected", self.data);
        self.btnBg:setAltas("iconantlas1", "tab3_souchong_select");
    else
        self.btnBg:setAltas("iconantlas1", "tab3_souchong_normal");
    end
end














Lua_ZodiacIntensifyHoleItem = class("Lua_ZodiacIntensifyHoleItem", Lua_ListCell);
function Lua_ZodiacIntensifyHoleItem:ctor(p)	
	self:superCall("ctor", p, "ZodiacIntensifyHoleItem_skin");
end

function Lua_ZodiacIntensifyHoleItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
    self.itemImg:setDepth(10);
    self.itemImg:setLocation(0, 0, 0);
    self.itemImg:setCanClick(false);

    self.itemSelect = UICreate.createUIAtlasImage(self.content, "zodiac", "item_select", 0, 0, 90, 90)
    self.itemSelect:setDepth(11);
    self.itemSelect:setEnable(false);
end

function Lua_ZodiacIntensifyHoleItem:dispose()
	self:superCall("dispose");
end

function Lua_ZodiacIntensifyHoleItem:setData(data)
	self.data = data;

	if data.equipVo ~= nil then
		self.suoSp:setEnable(false);
		self.itemImg.data = data.equipVo;
		self.iLevel.text = LanUtil.formateStr(LanUtil.getValue(143453), tostring(self.data.intensifyLevel));

		if data.isEquipCanIntensify or data.isEquipCanUpgrade then
			self.redDot:setEnable(true);
		else
			self.redDot:setEnable(false);
		end
	else
		self.suoSp:setEnable(true);
		self.redDot:setEnable(false);
		self.itemImg.data = nil;
		self.iLevel.text = "";
	end
end

function Lua_ZodiacIntensifyHoleItem:onSelectionChange(val)
	self:superCall("onSelectionChange");
    if val == true then
    	self.itemSelect:setEnable(true);
	    Lua_MsgUtil.callFunc("ZodiacIntensifyItemSelected", self.data);
	else
		self.itemSelect:setEnable(false);
    end
end