-- 生肖背包
checkRequire("Lua_ZodiacEquipHoleItem");
Lua_ZodiacPackWindow = class("Lua_ZodiacPackWindow", Lua_SecondSizeWindow);
function Lua_ZodiacPackWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_ZodiacPackWindow";
	self.skinName = "ZodiacPackWindow_skin";
	self.titleText = LanUtil.getValue(143408);
end

function Lua_ZodiacPackWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.holeArr = Array();
	local holePos = {{-330, 138}, {-94, 140}, {-333, -135}, {-95, -135}};
	for i,v in ipairs(holePos) do
		local holeItem = Lua_ZodiacEquipHoleItem.new(self.content, 0);
		holeItem:setLocation(v[1], v[2], 0);
		self.holeArr:add(holeItem);
	end

	self.headImg = UICreate.createImage(self.content, "", -214, -4, 0, 0);
	self.headImg:setDepth(10);

	self.packList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 388, 452));
    self.packList:setLocation(305, 5, 0);
    self.packList:setListCell(Lua_ZodiacPackItem, 85, 98, 4);

    self.subBtn:addClickFuntion(self, self.onSelectTypeClick);
	self:setSelectType(DataCenter.zodiacData.selectZodiacId);

	self:addLuaEvent("UPDATE_ALL_ZODIAC", self, self.updatePanelInfo);
	self:addLuaEvent("PACK_UPDATE", self, self.updatePackInfo);
	self:updatePanelInfo();
    self:updatePackInfo();
end

function Lua_ZodiacPackWindow:dispose()
	if self.packList ~= nil then
		self.packList:dispose();
		self.packList = nil;
	end

	for i = 1, self.holeArr:getSize() do
		self.holeArr[i]:dispose();
	end
	self.holeArr:clear();

	self:superCall("dispose");
end

function Lua_ZodiacPackWindow:updatePanelInfo()
	local zodiacId = DataCenter.zodiacData.selectZodiacId;
	local vo = DataCenter.zodiacUtil:getZodiacVoById(zodiacId);
	if vo ~= nil then
		for k,v in pairs(vo.holeVoDic) do
			if v.holePart ~= nil then
				self.holeArr[v.holePart]:setData(v);
			end
		end
	end
	self.headImg:setUrl(vo.headStr);
end

function Lua_ZodiacPackWindow:updatePackInfo()
	local bagData = DataCenter.packData:getBagType(Lua_PackData.ZODIAC_PACK);
	local arr = bagData:getItemsBySubType({ Lua_PackTypeDefine.ZODIAC_EQUIP_ITEM });
	local len = DataCenter.zodiacUtil.packSize;
	local itemArr = Array();

	for i = 1, len do
		if arr[i] ~= nil and arr[i].career == self.selectType then
			local sortNum = 100000 + arr[i].order * 1000 + arr[i].color * 100 + (arr[i].part * 10);
			itemArr:add({ vo = arr[i], sortNum = sortNum });
		else
			itemArr:add({ vo = nil, sortNum = 0 });
		end
	end

	itemArr:sort("sortNum", true);
	self.packList:setLuaArrayData(itemArr, false);
	self.packList:moveToIndex(1,true);
end

function Lua_ZodiacPackWindow:onSelectTypeClick()
	local dragData = {};
    dragData.datas = Array();
    dragData.datas:add(LanUtil.getValue(143412));
    dragData.datas:add(LanUtil.getValue(143413));
    dragData.datas:add(LanUtil.getValue(143414));
    dragData.datas:add(LanUtil.getValue(143415));
    dragData.datas:add(LanUtil.getValue(143416));
    dragData.datas:add(LanUtil.getValue(143417));
    dragData.datas:add(LanUtil.getValue(143418));
    dragData.datas:add(LanUtil.getValue(143419));
    dragData.datas:add(LanUtil.getValue(143420));
    dragData.datas:add(LanUtil.getValue(143421));
    dragData.datas:add(LanUtil.getValue(143422));
    dragData.datas:add(LanUtil.getValue(143423));
    dragData.width = 200;
    dragData.height = 345;
    dragData.offsetX = 405;
    dragData.offsetY = -80;
    dragData.callBackOwner = self;
    dragData.callBack = self.onSelectCallBack;
    dragData.selected = self.selectType;
    Lua_WindowUtil.openWin("Lua_DragDownWindow", nil, dragData);
end

function Lua_ZodiacPackWindow:onSelectCallBack(val)
    self:setSelectType(val);
    self:updatePackInfo();
end

function Lua_ZodiacPackWindow:setSelectType(val)
    self.selectType = val;

	if val == 1 then
		self.subTxt.text = LanUtil.getValue(143412);
	elseif val == 2 then
		self.subTxt.text = LanUtil.getValue(143413);
	elseif val == 3 then
		self.subTxt.text = LanUtil.getValue(143414);
	elseif val == 4 then
		self.subTxt.text = LanUtil.getValue(143415);
	elseif val == 5 then
		self.subTxt.text = LanUtil.getValue(143416);
	elseif val == 6 then
		self.subTxt.text = LanUtil.getValue(143417);
	elseif val == 7 then
		self.subTxt.text = LanUtil.getValue(143418);
	elseif val == 8 then
		self.subTxt.text = LanUtil.getValue(143419);
	elseif val == 9 then
		self.subTxt.text = LanUtil.getValue(143420);
	elseif val == 10 then
		self.subTxt.text = LanUtil.getValue(143421);
	elseif val == 11 then
		self.subTxt.text = LanUtil.getValue(143422);
	elseif val == 12 then
		self.subTxt.text = LanUtil.getValue(143423);
	end
end




















Lua_ZodiacPackItem = class("Lua_ZodiacPackItem", Lua_ListCell);
function Lua_ZodiacPackItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_ZodiacPackItem:buildShowItem()
    self:superCall("buildShowItem");

    self.itemImg = Lua_ToolImage.new(self.content);
    self.itemImg.defaultRoundEffect = true;
    self.itemImg:setDepth(5);
    self.itemImg:setLocation(0, 0, 0);
    self.itemImg:setCanClick(false);
end

function Lua_ZodiacPackItem:dispose()
    self:superCall("dispose");
end

function Lua_ZodiacPackItem:checkOutBound(showRect)
    local rect = Lua_Rectangle.new(self.itemX + 5 - 40, self.itemY - 40, 80, 80);
    if showRect:containeRect(rect) == true then
        self.itemImg:showRoundEffectView(true);
    else
        self.itemImg:showRoundEffectView(false);
    end
end

function Lua_ZodiacPackItem:setData(data)
    self.data = data.vo;
    self.itemImg.data = data.vo;
end

function Lua_ZodiacPackItem:onPlayerSoundClick(go)
	if self.data ~= nil then
	    Lua_PackUtil.showItemInfo(self.data);
	end
end