-- 生肖装备分解
Lua_ZodiacResolveWindow = class("Lua_ZodiacResolveWindow", Lua_SecondSizeWindow);
function Lua_ZodiacResolveWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_ZodiacResolveWindow";
	self.skinName = "ZodiacResolveWindow_skin";
	self.titleText = LanUtil.getValue(143411);
end

function Lua_ZodiacResolveWindow:buildShowItem()
	self:superCall("buildShowItem");

    self.resolveArr = Array();

	self.packList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 962, 436));
    self.packList:setLocation(6, 16, 0);
    self.packList:setListCell(Lua_ZodiacResolveItem, 90, 97, 10);

	self.subBtn1:addClickFuntion(self, self.onSelectColorClick);   -- 选择分解品质
    self.subBtn2:addClickFuntion(self, self.onSelectOrderClick);   -- 选择分解星级
    self:setSelectColor(DataCenter.zodiacData.packSelectColor);
    self:setSelectOrder(DataCenter.zodiacData.packSelectOrder);
    
    self.resolveItem.clickScale = false;
    self.resolveItem:addClickFuntion(self, self.onRresolveItemClick);
	self.resolveBtn:addClickFuntion(self, self.onResolveBtnClick);

    self:addLuaEvent("UPDATE_EQUIP_RESOLVE_SELCET", self, self.onSelectInfo);
    self:addLuaEvent("PACK_UPDATE", self, self.updatePackInfo);
	self:updatePackInfo();
end

function Lua_ZodiacResolveWindow:dispose()
	if self.packList ~= nil then
		self.packList:dispose();
		self.packList = nil;
	end

	self:superCall("dispose");
end

function Lua_ZodiacResolveWindow:onSelectInfo()
    self:updateSelect();
    self:updateResolveData();
end

function Lua_ZodiacResolveWindow:updateSelect()
    if self.packList ~= nil then
        local arr = self.packList.showList;
        local len = arr:getSize();
        for i = 1, len do
            arr[i]:updateSelect();
        end
    end
end

function Lua_ZodiacResolveWindow:updatePackInfo()
    local bagData = DataCenter.packData:getBagType(Lua_PackData.ZODIAC_PACK);
    local arr = bagData:getBagAllData()
    local len = DataCenter.zodiacUtil.packSize;
    self.resolveList = Array();
    for i = 1, len do
        if arr[i] ~= nil then
            local sortNum = 0;
            if arr[i].subType == Lua_PackTypeDefine.ZODIAC_EQUIP_RESOLVE_ITEM then -- -- 分解材料
                sortNum = arr[i].color;
            elseif arr[i].subType == Lua_PackTypeDefine.ZODIAC_EQUIP_ITEM then -- -- 生肖装备
                sortNum = 100000 + arr[i].order * 1000 + arr[i].color * 100 + (arr[i].part * 10);
            end
            self.resolveList:add({ vo = arr[i], isSelect = self:checkSelect(arr[i]), sortNum = sortNum });
        else
            self.resolveList:add({ vo = nil, isSelect = false, sortNum = 99999999 });
        end
    end

    self.resolveList:sort("sortNum", false);
	self.packList:setLuaArrayData(self.resolveList, false);

    self:updateResolveData();
end

function Lua_ZodiacResolveWindow:checkSelect(vo)
    if vo == nil then
        return false;
    end

    if vo.subType == Lua_PackTypeDefine.ZODIAC_EQUIP_RESOLVE_ITEM then -- 分解材料
        return true;
    end

    if vo.color <= self.selectColor + 1 then
        if self.selectOrder == 1 and vo.order <= 18 then
            return true;
        elseif self.selectOrder == 2 and vo.order <= 3 then
            return true;
        elseif self.selectOrder == 3 and vo.order <= 4 then
            return true;
        elseif self.selectOrder == 4 and vo.order <= 5 then
            return true;
        elseif self.selectOrder == 5 and vo.order <= 6 then
            return true;
        elseif self.selectOrder == 6 and vo.order <= 7 then
            return true;
        elseif self.selectOrder == 7 and vo.order <= 8 then
            return true;
        elseif self.selectOrder == 8 and vo.order <= 9 then
            return true;
        end
    end

    return false;
end

function Lua_ZodiacResolveWindow:updateResolveData() -- 分解数据
    self.resolveArr:clear();
    local len = self.resolveList:getSize();
    for i = 1, len do
        if self.resolveList[i].isSelect == true then
            local list = {};
            list.index = self.resolveList[i].vo.index;
            list.id = self.resolveList[i].vo.id;
            self.resolveArr:add(list);      
        end
    end

    if self.resolveArr:getSize() > 0 then
        local resolveNum = DataCenter.zodiacUtil:resolveTotalNum(self.resolveArr);
        self.resolveTxt.text = LanUtil.formateStr(LanUtil.getValue(143429), tostring(resolveNum));
    else
        self.resolveTxt.text = LanUtil.formateStr(LanUtil.getValue(143429), tostring(0));
    end
end

function Lua_ZodiacResolveWindow:onSelectColorClick()
	local dragData = {};
    dragData.datas = Array();
    dragData.datas:add(LanUtil.getValue(124424));
    dragData.datas:add(LanUtil.getValue(124425));
    dragData.datas:add(LanUtil.getValue(124426));
    dragData.width = 180;
    dragData.offsetX = -400;
    dragData.offsetY = -140;
    dragData.callBackOwner = self;
    dragData.callBack = self.onSelectColorCallBack;
    dragData.selected = self.selectColor;
    Lua_WindowUtil.openWin("Lua_DragDownWindow", nil, dragData);
end

function Lua_ZodiacResolveWindow:onSelectColorCallBack(val)
    DataCenter.zodiacData.packSelectColor = val;
    self:setSelectColor(val);
    self:updatePackInfo();
    self:updateResolveData();
end

function Lua_ZodiacResolveWindow:setSelectColor(val)
    self.selectColor = val;

	if val == 1 then
		self.subTxt1.text = LanUtil.getValue(124418);
	elseif val == 2 then
		self.subTxt1.text = LanUtil.getValue(124419);
	elseif val == 3 then
		self.subTxt1.text = LanUtil.getValue(124420);
	end
end

function Lua_ZodiacResolveWindow:onSelectOrderClick()
	local dragData = {};
    dragData.datas = Array();
    dragData.datas:add(LanUtil.getValue(143430));
    dragData.datas:add(LanUtil.getValue(143431));
    dragData.datas:add(LanUtil.getValue(143432));
    dragData.datas:add(LanUtil.getValue(143433));
    dragData.datas:add(LanUtil.getValue(143434));
    dragData.datas:add(LanUtil.getValue(143435));
    dragData.datas:add(LanUtil.getValue(143436));
    dragData.datas:add(LanUtil.getValue(143437));
    dragData.width = 180;
    dragData.height = 345;
    dragData.offsetX = -190;
    dragData.offsetY = -70;
    dragData.callBackOwner = self;
    dragData.callBack = self.onSelectOrderCallBack;
    dragData.selected = self.selectOrder;
    Lua_WindowUtil.openWin("Lua_DragDownWindow", nil, dragData);
end

function Lua_ZodiacResolveWindow:onSelectOrderCallBack(val)
    DataCenter.zodiacData.packSelectOrder = val;
    self:setSelectOrder(val);
    self:updatePackInfo();
    self:updateResolveData();
end

function Lua_ZodiacResolveWindow:setSelectOrder(val)
    self.selectOrder = val;

	if val == 1 then
		self.subTxt2.text = LanUtil.getValue(143430);
	elseif val == 2 then
		self.subTxt2.text = LanUtil.getValue(143431);
	elseif val == 3 then
		self.subTxt2.text = LanUtil.getValue(143432);
	elseif val == 4 then
		self.subTxt2.text = LanUtil.getValue(143433);
	elseif val == 5 then
		self.subTxt2.text = LanUtil.getValue(143434);
	elseif val == 6 then
		self.subTxt2.text = LanUtil.getValue(143435);
	elseif val == 7 then
		self.subTxt2.text = LanUtil.getValue(143436);
	elseif val == 8 then
		self.subTxt2.text = LanUtil.getValue(143437);
	end
end

function Lua_ZodiacResolveWindow:onResolveBtnClick(go)
    if self.resolveArr == nil or self.resolveArr:getSize() <= 0 then
        OperateAlert.show(LanUtil.getValue(143492));
        return;
    end

	Lua_ProxyManager.getProxy("Lua_ZodiacProxy"):sResolveEquip(self.resolveArr);
    if self.resolveList ~= nil then
        self.resolveList:clear();
    end
    if self.resolveArr ~= nil then
        self.resolveArr:clear();
    end
end

function Lua_ZodiacResolveWindow:onRresolveItemClick(go)
    Lua_PackUtil.showItemInfo(DataCenter.zodiacUtil.intensifyCostVo);
end




















Lua_ZodiacResolveItem = class("Lua_ZodiacResolveItem", Lua_ListCell);
function Lua_ZodiacResolveItem:ctor(p)
    self:superCall("ctor", p, nil);
end

function Lua_ZodiacResolveItem:buildShowItem()
    self:superCall("buildShowItem");

    self.itemImg = Lua_ToolImage.new(self.content);
    self.itemImg:setDepth(3);
    self.itemImg:setLocation(0, 0, 0);
    self.itemImg:setCanClick(false);

    self.tick = UICreate.createUIAtlasImage(self.content, "iconantlas1", "tick_green", 0, 6, 0, 0);
    self.tick:setDepth(10);
    self.tick:setEnable(false);
end

function Lua_ZodiacResolveItem:dispose()
    self:superCall("dispose");
end

function Lua_ZodiacResolveItem:setData(data)
    self.data = data;
    self.itemImg.data = data.vo;
    self:updateSelect();
end

function Lua_ZodiacResolveItem:updateSelect()
    if self.data.isSelect == true then
        self.tick:setEnable(true);
        self.itemImg:setGray(true);
    else
        self.tick:setEnable(false);
        self.itemImg:setGray(false);
    end
end

function Lua_ZodiacResolveItem:onPlayerSoundClick(go)
    if self.data.vo ~= nil then
        if self.data.isSelect == true then
            self.data.isSelect = false;
        else
            self.data.isSelect = true;
        end
        Lua_MsgUtil.callFunc("UPDATE_EQUIP_RESOLVE_SELCET");
    end
end