-- 扩展技能
Lua_ZodiacSkillExtendWindow = class("Lua_ZodiacSkillExtendWindow", Lua_Window);
function Lua_ZodiacSkillExtendWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_ZodiacSkillExtendWindow";
	self.skinName = "ZodiacSkillExtendWindow_skin";
end

function Lua_ZodiacSkillExtendWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
    self.itemImg:setDepth(10);
    self.itemImg:setLocation(-155, -190, 0);
    self.itemImg:setCanClick(true);

	self.leftList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 266, 274));
    self.leftList:setLocation(-205.5, 38, 0);
    self.leftList:setListCell(Lua_SkillExtendPropLeftItem, 55, 90, 1);
    self.leftList.canDrag = false; 

    self.rightList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 266, 274));
    self.rightList:setLocation(247, 38, 0);
    self.rightList:setListCell(Lua_SkillExtendPropRightItem, 55, 90, 1);
    self.rightList.canDrag = false;

    self.maxLevel:setEnable(false);
    self.upBtn:addClickFuntion(self, self.onUpBtnClick);

    self:addLuaEvent("UPDATE_ALL_ZODIAC", self, self.updatePanelInfo);
    self:updatePanelInfo();
end

function Lua_ZodiacSkillExtendWindow:dispose()
	if self.leftList ~= nil then
		self.leftList:dispose();
		self.leftList = nil;
	end

	if self.rightList ~= nil then
		self.rightList:dispose();
		self.rightList = nil;
	end

	self:superCall("dispose");
end

function Lua_ZodiacSkillExtendWindow:updatePanelInfo()
	local skillLevel = DataCenter.zodiacData.extendSkillLevel;

	local leftVo = DataCenter.zodiacUtil:getSkillExtendVoById(skillLevel);
	if leftVo ~= nil then
		self.leftList:setLuaArrayData(leftVo.attrsArr, false);
	end

	local rightVo = DataCenter.zodiacUtil:getSkillExtendVoById(skillLevel + 1);
	if rightVo == nil then
		self.desLabel:setEnable(false);
		self.itemImg:setEnable(false);
		self.upBtn:setBtnEnable(false);
		self.rightList:setEnable(false);
		self.maxLevel:setEnable(true);
		self.redDot:setEnable(false);
	else
		self.rightList:setLuaArrayData(rightVo.attrsArr, false);

		local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
		self.haveNum = bagData:getItemNum(leftVo.expendVo.id);
		self.needNum = leftVo.expendVo.count;
		self.itemImg.data = leftVo.expendVo;
		self.itemImg:showNumLimit(self.haveNum, self.needNum , 2);

		if self.haveNum >= self.needNum then
			self.redDot:setEnable(true);
		else
			self.redDot:setEnable(false);
		end
	end
end

function Lua_ZodiacSkillExtendWindow:onUpBtnClick(go)
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
        OperateAlert.show(LanUtil.getValue(121419));
        return;
    end
    self.clickTime = getTime();
    
	if self.haveNum < self.needNum then
		OperateAlert.show(LanUtil.getValue(143465));
		return;
	end

	Lua_ProxyManager.getProxy("Lua_ZodiacProxy"):sSkillExtend();
end




















Lua_SkillExtendPropLeftItem = class("Lua_SkillExtendPropLeftItem", Lua_ListCell);
function Lua_SkillExtendPropLeftItem:ctor(p)
    self:superCall("ctor", p, nil);
end

function Lua_SkillExtendPropLeftItem:buildShowItem()
	self:superCall("buildShowItem");

	self.propTxt = UICreate.createLabel(self.content, "", 0, 0, 200, 24, 24);
    self.propTxt.pivot = UIWidget.Pivot.Left;
    self.propTxt.overflowMethod = UILabel.Overflow.ResizeFreely;
    self.propTxt:setDepth(10);
    self.propTxt:setLocation(0, 0, 0);
end

function Lua_SkillExtendPropLeftItem:dispose()
	self:superCall("dispose");
end

function Lua_SkillExtendPropLeftItem:setData(data)
	self.propTxt.text = "[3F6180]"..data.name.."[-]".."[192E41]"..data.value.."[-]";
end









Lua_SkillExtendPropRightItem = class("Lua_SkillExtendPropRightItem", Lua_ListCell);
function Lua_SkillExtendPropRightItem:ctor(p)
    self:superCall("ctor", p, nil);
end

function Lua_SkillExtendPropRightItem:buildShowItem()
	self:superCall("buildShowItem");

	self.propTxt = UICreate.createLabel(self.content, "", 0, 0, 200, 24, 24);
    self.propTxt.pivot = UIWidget.Pivot.Left;
    self.propTxt.overflowMethod = UILabel.Overflow.ResizeFreely;
    self.propTxt:setDepth(10);
    self.propTxt:setLocation(0, 0, 0);
end

function Lua_SkillExtendPropRightItem:dispose()
	self:superCall("dispose");
end

function Lua_SkillExtendPropRightItem:setData(data)
	self.propTxt.text = "[3F6180]"..data.name.."[-]".."[13A100]"..data.value.."[-]";
end