Lua_ZodiacSkillItem = class("Lua_ZodiacSkillItem", Lua_DisplayObject);
function Lua_ZodiacSkillItem:ctor(p)	
	self:superCall("ctor", p, "ZodiacSkillItem_skin");
end

function Lua_ZodiacSkillItem:buildShowItem()
	self:superCall("buildShowItem");

	self.redDot:setEnable(false);
	self.funcBtn:setBtnEnable(false);
	self.funcBtn.label = LanUtil.getValue(143405);
	self.funcBtn:addClickFuntion(self, self.onFuncBntClick);
	
	self.skillIcon.clickScale = false;
	self.skillIcon:addClickFuntion(self, self.onSkillIconClick);
end

function Lua_ZodiacSkillItem:dispose()
	self:superCall("dispose");
end

function Lua_ZodiacSkillItem:setData(data)
	if data == nil then
		return;
	end
	
	self.data = data;
	self.skillIcon:setAltas(data.atlasName, data.iconName);
	self.skillLevel.text = "Lv."..data.lv;
	if data.state == 0 then -- 未激活
		self.skillIcon:setGray(true);
		self.funcBtn:setBtnEnable(false);
		self.funcBtn.label = LanUtil.getValue(143405);
		self.redDot:setEnable(false);
	else
		self.funcBtn:setBtnEnable(true);
		self.skillIcon:setGray(false);
		if data.state == 1 then -- 未使用
			self.funcBtn.label = LanUtil.getValue(110822);
			self.redDot:setEnable(DataCenter.zodiacData.skillHaveUse);
		elseif data.state == 2 then -- 已使用
			self.funcBtn.label = LanUtil.getValue(124439);
			self.redDot:setEnable(false);
		end
	end
end

function Lua_ZodiacSkillItem:onSkillIconClick(go)
	Lua_WindowUtil.openWin("Lua_ZodiacSkillDetailWindow", WinParam.ACTION_OPEN, self.data);
end

function Lua_ZodiacSkillItem:onFuncBntClick(go)
	local zodiacIndex = DataCenter.zodiacData.selectZodiacId;
	if self.data.state == 1 then -- 未使用
		if DataCenter.zodiacData.skillHaveUse == false then
			OperateAlert.show(LanUtil.getValue(143469));
			return;
		end
		Lua_ProxyManager.getProxy("Lua_ZodiacProxy"):sUseZodiacSkill(zodiacIndex, true);
	elseif self.data.state == 2 then -- 已使用
		Lua_ProxyManager.getProxy("Lua_ZodiacProxy"):sUseZodiacSkill(zodiacIndex, false);
	end
end